#include <stdio.h>
#include <string.h>
// prototipo della funzione che ritorna un numero intero da una stringa esadecimale
int htoi(char* strnum);

int main (void)
{
    FILE *fp; char szEthernetFrame[100];
    char szTypeLen[5]; int idx; int v;

    fp = fopen ("frameeth.txt", "r");
    if (fgets (szEthernetFrame, 100, fp) == NULL ) return 1;
    fclose (fp);
    printf("frame Ethernet:  %s .. ..",szEthernetFrame);

    idx = 13; idx = (idx-1)*3;
    szTypeLen[0] = szEthernetFrame[idx]; szTypeLen[1] = szEthernetFrame[idx+1];
    idx = 14; idx = (idx-1)*3;
    szTypeLen[2] = szEthernetFrame[idx]; szTypeLen[3] = szEthernetFrame[idx+1]; szTypeLen[4]=0;

    v = htoi(szTypeLen);  // conversione in intero
    printf("\nType/lenght: %sh (%d)",szTypeLen, v);

    if (v>1500)
    {
      printf("\nframe Ethernet 2, Ethertype: %sh ",szTypeLen);
    }
    else
    {
      idx = 15; idx = (idx-1)*3;
      szTypeLen[0]=szEthernetFrame[idx]; szTypeLen[1]=szEthernetFrame[idx+1]; szTypeLen[2]=0;
      if (!strcmp(szTypeLen, "aa"))
      {
         printf("\nframe Ethernet 802.3 SNAP, lunghezza: %d ",v);
      }
      else
      {
         printf("\nframe Ethernet 802.3 LLC, lunghezza: %d ",v);
      }
    }

    return 0;
}

int htoi(char* strnum)
{
    int value = 0; char *p;

    p = strnum;
    while(*p )
    {
        if (*p >= '0' && *p <= '9') value = value * 16 + *p - '0';
        else value = value * 16 + *p - 'a' + 10;
        p++;
    }
    return value;
}

